/* #define ANSI */ /* remove comments to compile ANSI.SYS-compatible version*/

/* #define TC  */  /* remove comments to compile with Turbo C 2.0           */

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <ctype.h>
#include <conio.h>
#include <dos.h>
#include <time.h>
#include <sys\types.h>
#include <sys\stat.h>

#ifndef TRUE
	#define TRUE 1
	#define FALSE 0
#endif

#ifdef MAIN
	#define loc
#else
	#define loc extern
#endif

#ifdef TC						/* definitions of FP_SEG and FP_OFF from */
	#undef FP_SEG				/* Microsoft dos.h include file... used  */
	#undef FP_OFF				/* here for compatibility purposes       */
	#define FP_SEG(fp) (*((unsigned *)&(fp) + 1))
	#define FP_OFF(fp) (*((unsigned *)&(fp)))
#endif

void short_help(void);
void full_help(void);
void get_vid_parms(void);
int  file_exists(char *s);
void read_file(char *s);
void parse_line(char *s);
char *get_arg(char *s);
void one_line(int argc, char *argv[]);
void say     (int argc, char *argv[]);
void say_at  (int argc, char *argv[]);
void ask     (int argc, char *argv[]);
void ask_at  (int argc, char *argv[]);
void cls     (int argc, char *argv[]);
void dlay    (int argc, char *argv[]);
void wait    (int argc, char *argv[]);
void beep    (int argc, char *argv[]);
void type    (int argc, char *argv[]);
void typechar(int argc, char *argv[]);
void color   (int argc, char *argv[]);
void reptchar(int argc, char *argv[]);
void skpline (int argc, char *argv[]);
void box     (int argc, char *argv[]);
void inc     (int argc, char *argv[]);
void dec     (int argc, char *argv[]);

void set_cursor(int col, int row);
void set_color(int fore, int back);
void ms_delay(clock_t count);
void wait_time(char *t);
void make_beep(unsigned freq, unsigned dur);
void show_char(int ch);
void vid_out(int ch);
void show_line(char *s, int lf);
void scroll_up(void);

loc union REGS ireg, oreg;
loc unsigned vid_seg, vid_start, vid_page, 
				 vid_rows, vid_cols, vid_mode,
				 vid_attr, curs_row, curs_col;
loc int exit_val;
